; ----------------------------------------------------------------------------------------
; template.asm
; ----------------------------------------------------------------------------------------


global main
extern printf, atoi


%macro output 1 
	pusha
	push %1
	push %1
	push output_format
	call printf
	add esp, 12
	popa
%endmacro

%macro write_num 1
	pusha
	push %1
	push write_num_format
	call printf
	add esp, 8
	popa
%endmacro

%macro write_hex 1
	pusha
	push %1
	push write_hex_format
	call printf
	add esp, 8
	popa
%endmacro

%macro write_string 1
	pusha
	push %1
	push write_string_format
	call printf
	add esp, 8
	popa
%endmacro



[section .text]

main:	; "Prolog" -- nicht aendern
        push    ebp 
        mov     ebp,esp 

	; Einstieg
	mov ecx, [ebp+8]   ; argc
	mov ebx, [ebp+12]  ; argv

	push dword [ebx+4] ; argv[1] = erstes Argument
	call atoi
	add esp, 4
	mov [param1], eax

	push dword [ebx+8] ; argv[2] = zweites Argument
	call atoi
	add esp, 4
	mov [param2], eax


	; Beispiel-Anwendung: Schleife von arg1 bis arg2

	mov eax, [param1]
loop:	write_num eax
	write_string blank
	inc eax
	cmp eax, [param2]
	jle loop
	write_string newline


finish: ; eax ausgeben und verlassen
	; output eax

end:
	mov eax, 0   ; Exitcode 0 (ggf anpassen)

	; "Epilog" -- nicht aendern
	mov esp, ebp
	pop ebp	
        ret          ; Rueckkehr in den C Wrapper


[section .bss]

; Platz fuer Variablen (nicht initialisiert)
param1:	resb 4
param2: resb 4


[section .data]

; Eigene Daten
message: db "Hallo Welt", 10, 0



; Standard-Format-Strings
output_format:         db "Ergebnis: 0x%x = %d", 10, 0
write_num_format:      db "%d", 0
write_hex_format:      db "0x%x", 0
write_string_format:   db "%s", 0
newline:               db 10, 0
blank:                 db " ", 0


